<?php 

require_once(realpath(dirname(__FILE__)).'/ParticleTraffic.config.php');

//'magic' quotes are dumb. 
if (get_magic_quotes_gpc()) {
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while (list($key, $val) = each($process)) {
        foreach ($val as $k => $v) {
            unset($process[$key][$k]);
            if (is_array($v)) {
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            } else {
                $process[$key][stripslashes($k)] = stripslashes($v);
            }
        }
    }
    unset($process);
}

$_REQUEST['url'] = str_replace('colslashtemp','://',$_REQUEST['url']);

switch($_REQUEST['mode']){

	//the required javascript for showing the traffic data interface
	case 'track_event':
	
		$siteIdNumber=0;
		ParticleTrafficTracker::quickTrack( array('title'=>$_REQUEST['title'], 'siteIdNumber'=>$_REQUEST['site'], 'url'=>$_REQUEST['url'], 'eventOnly'=>$_REQUEST['eo'], 'eventValue'=>$_REQUEST['ev']) );
		
		ParticleTrafficTools::printSpacerImg(); 
		
		try{
			//is cUrl installed? 
			$curlData=@curl_version(); 
			if(is_array($curlData) && intval($curlData['version_number'])>0){   
				//let the server start a new process with cUrl, so it doesn't tie up the user's assigned process 
				//borrowing this idea from ryan   
				$ch = curl_init( BASE_URL . View::url(ParticleTraffic_SERVICES_URL.'?mode=cacheOld') );
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_HEADER, 0); 
				curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,1);  
				curl_setopt($ch, CURLOPT_TIMEOUT,1);
				$result = curl_exec($ch); 
				curl_close($ch); 				
			} 
		}catch(Exception $e){
			//suppressing any errors with cUrl, since this regular caching isn't too important 
		}
		
		die;
		break;
		
	case 'page_unload':	 
		ParticleTrafficTracker::pageUnload(); 
		ParticleTrafficTools::printSpacerImg(); 
		die;
		break; 	
		
		
	case 'cacheOld':	 
		//run caching routine, if it hasn't been run recently  
		if( intval(Config::get('TONY_STATS_LAST_CACHED')) < (time()-(60*60*24)) ){  
			$display = new ParticleTrafficDisplay();
			$display->getVisitData();
		}
		die;
		break; 

	//the required javascript for showing the traffic data interface
	case 'tracker_js':
	
		ob_start(); 
		include(ParticleTraffic_PATH.'js/ParticleTraffic.tracker_script.php');
		$output = ob_get_contents(); 
		ob_end_clean(); 
	
		header("Expires: ".date("D, d M Y H:i:s", (time() + (3600*24*7)) )." GMT"); 
		header("Pragma: public"); 
		header("content-type: application/x-javascript"); 
		header("Cache-Control: public, max-age=".(3600*24*7).", must-revalidate");
		$lastModified = @filemtime(ParticleTraffic_PATH.'js/ParticleTraffic.tracker_script.php'); 
		header("Last-Modified: " . gmdate("D, d M Y H:i:s",$lastModified) . " GMT");

		try{
			Loader::library('3rdparty/jsmin');
			echo (class_exists(JSMin) && method_exists(JSMin,'minify')) ? JSMin::minify($output) : $output;
		}catch(Exception $e){
			echo $output; 	
		}
		die;
		break;
		
	//the required javascript for showing the traffic data interface
	case 'save_tab':
		$_SESSION['statsPanel_'.$_REQUEST['panel']]=$_REQUEST['val']; 
		echo 'statsPanel_'.$_REQUEST['panel'];
		die;
		break;		
	
	//track the user information captured by the tracker_script (screen size, flash version, etc), and return a 1x1 transparent gif
	//done via a loaded image so we don't have to use ajax
	case 'tracking_img':
		
		$tracker = new ParticleTrafficTracker( intval($_REQUEST['site']) );
		$tracker->browserSideHit( );		
		ParticleTrafficTools::printSpacerImg();
		die;
		break;	

	//the required javascript for showing the traffic data interface
	case 'display_js':
	
		header("Expires: ".date("D, d M Y H:i:s", (time() + (3600*24*7)) )." GMT"); 
		header("Pragma: public"); 
		header("content-type: application/x-javascript"); 
		header("Cache-Control: public, max-age=".(3600*24*7).", must-revalidate"); 
		$siteIdNumber=intval($_REQUEST['site']);
		include(ParticleTraffic_PATH.'js/ParticleTraffic.display_script.php');
		die;
		break;		
		
	//get the xml for the site's visits graph
	case 'graph_xml':
		//you may want to aid some authentication here if you want to hide you sites traffic xml data

		//if(!ParticalStatsAuthentication::isLoggedIn()) return '';

		$timeframe=$_REQUEST['timeframe'];
		if(!in_array($timeframe,array('week','year','day')))
			$timeframe='week';
			
		$statsDisplay = new ParticleTrafficDisplay(intval($_REQUEST['bID']));
		$filePath = $statsDisplay->getGraphXMLPath($timeframe); 
		if( !file_exists($filePath) ){ 
			$visitData=$statsDisplay->getVisitData();
			$statsDisplay->generateGraphXML($visitData,$timeframe);
		}
		
		if(!file_exists($filePath)) throw new Exception('file not found!');
		$filesize=filesize($filePath); 	 
		header("Pragma: public"); 
		header("Cache-Control: must-revalidate");				
		header('Content-Type: text/xml');
		header('Content-Length: '.$filePath);
		
		$fp = fopen($filePath, 'r'); //'rb'
		$file_buffer = fread($fp, $filesize);
		fclose ($fp);			
		print $file_buffer;
		die;

		break; 
		
	default:
		echo 'No service specified';
		die;
}

?>