<?php 
if(!defined('ParticleTraffic_PATH')) die; 



//This is ParticleTraffic database abstraction layer (using a singleton pattern)
//It's intend to make swapping out adodb with a different method of connection a bit easier for you.

class ParticleTrafficDB{

	//Singleton pattern - only one every loaded
	private static $instance;
	private $db;
	private $db_host;
	private $db_username;
	private $db_password;
	private $database;
	public $queriesLog=array();
	
	//free's mySQL memory usage for large data sets
	public $free_results=false;

	private function __construct(){		
		/*
		$this->db_host = ParticleTraffic_DB_HOST;
		$this->database = ParticleTraffic_DB_NAME;
		$this->db_username = ParticleTraffic_DB_USERNAME;
		$this->db_password = ParticleTraffic_DB_PASSWORD;

		//connect to database
		$this->db = ADONewConnection(ParticleTraffic_DB_TYPE);
		//$this->db->debug = true;
		$this->db->Connect( $this->db_host, $this->db_username, $this->db_password, $this->database); 	
		*/
		$this->db = Loader::db();
	}
	
	//Singleton Pattern
	public static function get_instance(){ 
		if (empty(self::$instance)){
			self::$instance = new ParticleTrafficDB();
		}	
		return self::$instance;
	}
	
	//multi dimensional array - array containing rows!
	function get_array($query,$vals=array()){
		//$rs = $this->query($query,$this->dbLink);
		return $this->db->GetArray($query,$vals);
		/*
		$count = @mysql_num_rows($rs);
				for($i=0;$i<$count;$i++){
					$row = mysql_fetch_assoc($rs);
					$result_array[]=$row;
				}
		if($this->free_results) mysql_free_result($rs);
		if(intval($count)==0)$result_array=array(); 	
		return $result_array;
		*/
	}
	
	//single dimensional array
	function get_row($query, $resultType=MYSQL_ASSOC){
		if( !strstr(strtolower($query),' limit') && 
			!strstr(strtolower($query),' procedure') && 
			!strstr(strtolower($query),' into outfile') &&
			!strstr(strtolower($query),' into dumpfile') &&
			!strstr(strtolower($query),'show tables') &&
			!strstr(strtolower($query),' lock in share mode') && 
			!strstr(strtolower($query),' for update'))
				$query.=' LIMIT 1';
		return $this->db->GetRow($query);
		/*
		$array = @mysql_fetch_array($rs, $resultType);
		if($this->free_results) mysql_free_result($rs);
		return $array;
		*/		
	}
	
	function quote($v){ 
		return $this->db->quote($v);
	}
	
	//single element
	function get_field($query,$vals=array()){
		return $this->db->GetOne($query,$vals);
		/*
		$rs = $this->query($query);
		$array = @mysql_fetch_array($rs);
		if($this->free_results) mysql_free_result($rs);	
		return $array[0];
		*/
	} 
	
	//general queries
	function query($query,$vals=array()){
		$rs=$this->db->Execute($query,$vals);
		if(!$rs) {
			trigger_error( mysql_error().' '.$query, E_USER_WARNING );
			return false;
		} else {
			return $rs;
		}
				
		/*
		$this->lastSQL=$query;	
		if(QUERY_LOGGING_ON) $query_start=getMicroTimeMS();
		$rs = @mysql_query($query,$this->dbLink);
		if(QUERY_LOGGING_ON){
			$query_time=getMicroTimeMS()-$query_start;
			$this->queriesLog[$query_time.'.'.getMicroTimeMS()]=$query;
		}
		$this->lastSQL=$query;
		if(!$rs) {
			trigger_error( mysql_error().' '.$query, E_USER_WARNING );
			return false;
		} else {
			return $rs;
		}
		*/		
	}
	
	/*
	function queryLogEvent($event=''){
		$this->queriesLog[]=$event;
	}
	
	//same as query, but locks the DB so the insert ID will be guaranteed correct
	function queryWithLock($query,$tableName){
		mysql_query("LOCK TABLES $tableName WRITE");
		mysql_query($query);
		mysql_query("SELECT LAST_INSERT_ID()");
		$this_ID=mysql_insert_id();
		mysql_query("UNLOCK TABLES");
		return $this_ID;
	}
	*/
	
	function lastInsertID($IDcolumn,$tableName){
		//return mysql_insert_id() ;
		return $this->db->Insert_ID();
	}

	function nextID($IDcolumn,$tableName){
		$nextID='';
		if($IDcolumn && $tableName){
		 	$nextID=$this->maxID($IDcolumn,$tableName);
		 	$nextID=intval($nextID)+1;
		 }
		return $nextID;
	}
	
	function maxID($IDcolumn,$tableName){
		$maxID='';
		if($IDcolumn && $tableName){
		 	$maxID=$this->get_field("SELECT Max(".$IDcolumn.") FROM ".$tableName);
		 }
		return $maxID;
	}

	function escape($str){
		return mysql_real_escape_string($str);
	}
			
	function get_tables(){
		if($this->tables_fixed) return $this->tables_fixed;
		$sql = 'Show Tables';
		$this->tables_fixed=array();	
		$res = $this->get_array($sql);
		foreach($res as $table_array){
			foreach($table_array as $key=>$table) $this->tables_fixed[]=$table;
		}
		return $this->tables_fixed;
	 }
} 
?>