<?php  
defined('C5_EXECUTE') or die(_("Access Denied.")); 

global $c; 

$interfaceHelper = Loader::helper('concrete/interface'); 
$dashboardHelper = Loader::helper('concrete/dashboard'); 

?> 

<style>
table#resultsLimits { width:60% }
table#resultsLimits td { padding-right:12px; width:50%; }

.ccm-notification { background:#FFFFCC; color:#555; padding:4px; margin-bottom:16px; border:1px solid #ddd; font-weight:bold;  }
.ccm-note { font-size:11px; color:#999; margin-top:4px; }

#statsColumns, 
#statsColumns > tr > td, 
#statsColumns > tbody > tr > td{ border:0 none !important; padding:0 !important; }
#statsColumns table { border:0 none !important; } 
#statsColumns td { padding:2px !important; border:0 none !important; } 
</style>

<?php  if( method_exists( $dashboardHelper, 'getDashboardPaneHeaderWrapper') ){  
echo $dashboardHelper->getDashboardPaneHeaderWrapper(t('Traffic &amp; Statistics Settings'),t("Edit the settings of the Traffic &amp; Statistics package.")); 
}else{ ?> 
	<h1><span><?php echo t('Traffic &amp; Statistics Settings')?></span></h1> 
	<div class="ccm-dashboard-inner" > 
<?php  } ?> 

<div class="ParticleTraffic"> 

<table id="statsColumns" style="width:100%;" cellspacing="0" cellpadding="0"><tr><td valign="top" style="width:49%; ">

	<h3><span><?php echo t('Result Limits')?></span></h3>

	<div class="ccm-dashboard-stats-inner" >  
	
		<?php  if($panelSettingsSaved){ ?>
			<div class="ccm-notification"><?php echo  t('Changes Saved') ?></div>
		<?php  } ?>
		
		<form id="panelSettingsForm" method="post" action="<?php echo View::url( $c->getCollectionPath() )?>"> 
		
			<input name="submitPanelSettings" type="hidden" value="1" />
			
			<div style="margin-bottom:12px; font-weight:bold"><?php echo  t('Number of results to display:') ?></div>
			
			<table id="resultsLimits">
				<tr>
					<td><?php echo  t('Top/Recent Pages') ?></td>
					<td><input name="pagesLimit" type="text" value="<?php echo (intval($panelSettings['pagesLimit']))?intval($panelSettings['pagesLimit']):15 ?>" size="3" maxlength="3" /></td>
				</tr> 		
				<tr>
					<td><?php echo  t('User Visits') ?></td> 
					<td><input name="visitsLimit" type="text" value="<?php echo (intval($panelSettings['visitsLimit']))?intval($panelSettings['visitsLimit']):15 ?>" size="3" maxlength="3" /></td>
				</tr>
				<tr>
					<td><?php echo  t('Referrers') ?></td>
					<td><input name="referrersLimit" type="text" value="<?php echo (intval($panelSettings['referrersLimit']))?intval($panelSettings['referrersLimit']):15 ?>" size="3" maxlength="3" /></td>
				</tr>	
				<tr>
					<td><?php echo  t('Searches') ?></td>
					<td><input name="searchesLimit" type="text" value="<?php echo (intval($panelSettings['searchesLimit']))?intval($panelSettings['searchesLimit']):15 ?>" size="3" maxlength="3" /></td>
				</tr>
				<tr>
					<td><?php echo  t('Resolutions') ?></td>
					<td><input name="resolutionsLimit" type="text" value="<?php echo (intval($panelSettings['resolutionsLimit']))?intval($panelSettings['resolutionsLimit']):15 ?>" size="3" maxlength="3" /></td>
				</tr>											
			</table>
			
			<div style="margin-top:16px;float:left;" >
				<?php 
				$b1 = $interfaceHelper->submit(t('Save Changes &raquo;'), 'panelSettingsForm');
				print $interfaceHelper->buttons($b1);
				?>
				<br class="clear" /> 
			</div>
			<div class="ccm-spacer">&nbsp;</div>
		</form>
	
	</div>
	
	
	
</td><td width="2%">&nbsp;</td><td valign="top"> 
    
    <h3><span><?php echo t('Tracking')?></span></h3>

	<div class="ccm-dashboard-stats-inner" >  
	
		<?php  if($panelTrackingSaved){ ?>
			<div class="ccm-notification"><?php echo  t('Changes Saved') ?></div>
		<?php  } ?> 
		
		<form id="trackingSettingsForm" method="post" action="<?php echo View::url( $c->getCollectionPath() )?>"> 
		
			<input name="submitTrackingSettings" type="hidden" value="1" />
			
			<div style="margin-bottom:4px; font-weight:bold"><?php echo  t('Ignore visits by users in these groups: ') ?></div> 
			
			<div style="height:100px; overflow: auto; overflow-y: scroll; overflow-x: hidden; border:1px solid #ddd; padding:4px; margin-bottom:8px">
				<?php   
				$groupSearch = Loader::model('search/group'); 
				$groupSearch = new GroupSearch();
				$maxGroups=1000000000; //this defaulted to 100
				$groupSearch->setItemsPerPage($maxGroups);   
				$groupSearch->includeAllGroups();
				foreach($groupSearch->get($maxGroups) as $group ){ 
					if(intval(GUEST_GROUP_ID)==intval($group['gID'])) continue;
					?>
					<div>
						<input name="gIDs[]" type="checkbox" value="<?php echo intval($group['gID']) ?>" <?php echo (in_array(intval($group['gID']),$trackingSettings['gIDs']))?'checked="checked"':'' ?> />  
						<?php echo $group['gName'] ?> 
					</div> 
				<?php  } ?>
			</div> 
			
			<div style="margin-bottom:16px">
				<input name="ignoreUnlogged" type="checkbox" value="1" <?php echo intval($trackingSettings['ignoreUnlogged'])?'checked="checked"':'' ?> />  
				<?php echo t("Ignore these users even when they're not signed in") ?> 
			</div>	
			
			<div style="margin-bottom:8px">
				<div style="margin-bottom:2px; font-weight:bold"><?php echo  t('Ignored IPs / Domains: ') ?></div> 
				<textarea name="ignoredDomains" cols="50" rows="5" style="width:100%"><?php echo htmlspecialchars(join("\r",$trackingSettings['ignoredDomains'])) ?></textarea>
				<div class="ccm-note"><?php echo t('Put each on a separate line.') ?></div>
			</div>	
			
			<div style="margin-top:16px;float:left;" >
				<?php 
				$b1 = $interfaceHelper->submit(t('Save Changes &raquo;'), 'trackingSettingsForm');
				print $interfaceHelper->buttons($b1);
				
				
				?>
				<br class="clear" /> 
			</div>
			<div class="ccm-spacer">&nbsp;</div> 
		</form>
	
	</div>


    
    <h3><span><?php echo t('Displayed Panels')?></span></h3>

	<div class="ccm-dashboard-stats-inner" >  
	
		<?php  if($displayedPanelsSaved){ ?>
			<div class="ccm-notification"><?php echo  t('Changes Saved') ?></div>
		<?php  }elseif(count($registerPanelsResult['errors'])){ ?>
			<div style="margin-bottom:8px; ">
				<?php echo t('There are some problems with some of your stats panels: ') ?> 
				<a onclick="$('#panelErrorMsgs').toggle(); return false; " href="#"><?php echo t('Show') ?></a>
				<div id="panelErrorMsgs" style="display:none">
				<?php  foreach($registerPanelsResult['errors'] as $panelError){ ?> 
					<div><?php echo $panelError ?></div>
				<?php  } ?>
				</div>
			</div>
		<?php  } ?>
		
		<form id="displayedPanelsForm" method="post" action="<?php echo View::url( $c->getCollectionPath() )?>">  
			
			<input name="submitDisplayedPanels" type="hidden" value="1" />
			
			<div id="availablePanels"> 
			<?php  foreach($panels as $panel){ ?>
				<div class="panel <?php echo (!$panel->isEnabled())?'panelDisabled':'' ?>">
					<input name="panelDisplayed[]" type="checkbox" value="<?php echo  $panel->getPanelID() ?>" <?php echo ( $panel->isDisplayed() )?'checked':'' ?> /> 
					<?php echo $panel->getTitle(); ?>
				</div>
			<?php  } ?> 
			</div>
			
			
			<div class="ccm-spacer">&nbsp;</div>
			
			<div style="margin-top:8px;float:left;" >
				<?php 
				$b1 = $interfaceHelper->submit(t('Save Changes &raquo;'), 'displayedPanelsForm');
				print $interfaceHelper->buttons($b1);
				?>
				<br class="clear" /> 
			</div>
			<div class="ccm-spacer">&nbsp;</div>
		</form>
	
	</div>	
	
</td></tr></table>

</div> 

<?php  if( method_exists( $dashboardHelper, 'getDashboardPaneFooterWrapper') ){ 
	echo $dashboardHelper->getDashboardPaneFooterWrapper(); 
}else{ ?>  
	</div> 
<?php  } ?> 